# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc根据推送单号获取配货单信息,2295,2295-28,sit,bs
主数据平台:后台运营系统获取配货单信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取jde配货列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url2")
request_body = commonFuc().get_business_data(module, "payload2")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
dis_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取配货单信息
distribution_jde_ds_code = result["data"]["list"][dis_random]["distributionJdeDsCode"]

# 第三步进行条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url28")
request_body = commonFuc().get_business_data(module, "payload28", distribution_jde_ds_code)

"""

 场景: 根据推送单号获取配货单信息
 用例名称：根据推送单号获取配货单信息
 输出：{"distributionJdeDsCode":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取查询结果中distributionJdeDsCode
result = json.loads(result.content)
# print(result)
result = {"distributionJdeDsCode": result["data"]["list"][0]["distributionJdeDsCode"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict28", distribution_jde_ds_code)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
