# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc随货同行单导出验证,2294,2294-16,sit,bs
主数据平台:多采商城随货同行单导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
from common.handle_excel import HandleExcel
import random
import requests
import json
import os


module = "cmdc_trade"

# 第一步获取登录多采商城所需账号密码
username = commonFuc().get_business_data(module, "username3")
password = commonFuc().get_business_data(module, "password3")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取发货单物流信息列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url11")
request_body = commonFuc().get_business_data(module, "payload11")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
jde_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取发货单信息
demand_code = result["data"]["list"][jde_random]["demandCode"]
sd_random = random.randint(0, len(result["data"]["list"][jde_random]["SDDOCOList"]) - 1)
sddoco_1 = result["data"]["list"][jde_random]["SDDOCOList"][sd_random][:8]


# 第四步随货同行单导出
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21", demand_code, sddoco_1)

"""

 场景: 随货同行单导出验证
 用例名称：随货同行单导出验证
 输出：{"so":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/发货单号{}随货同行单导出.xlsx".format(sddoco_1)

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取文件中需求单号
excel = HandleExcel(file_path, "工作表1")
# print(excel.read_data())
result = {"so": excel.read_data()[0].get("出库单号：")}
# print(result)
result["api_time"] = api_time
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict21")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)